package tacv.universe.world;

import cz.agents.alite.planner.spatialmaneuver.zone.GroupZone;
import cz.agents.alite.planner.spatialmaneuver.zone.Zone;
import cz.agents.alite.vis.element.Line;
import java.util.ArrayList;
import java.util.LinkedHashSet;
import java.util.Set;
import javax.vecmath.Point3d;
import tacv.util.LineZoneVisitor;

/**
 *
 * @author Jiri Vokrinek
 */
public class CollisionZone {

    private final GroupZone collisionZone;
    private final Set<ArrayList<Line>> lines = new LinkedHashSet<ArrayList<Line>>();

    public CollisionZone(GroupZone collisionZone) {
        this.collisionZone = collisionZone;
        if (collisionZone != null) {
            for (Zone subZone : collisionZone.getSubZones()) {
                ArrayList<Line> zoneLines = new ArrayList<Line>();
                LineZoneVisitor lineZoneVisitor = new LineZoneVisitor(zoneLines);
                subZone.accept(lineZoneVisitor);
                lines.add(zoneLines);
            }
        }
    }

    public Set<ArrayList<Line>> getLines() {
        return new LinkedHashSet<ArrayList<Line>>(lines);
    }

    public boolean testPoint(Point3d point) {
        return collisionZone.testPoint(point);
    }

    public boolean testLine(Point3d point1, Point3d point2) {
        return collisionZone.testLine(point1, point2, new Point3d());
    }
   
}
