package tacv.vis;

import cz.agents.alite.vis.Vis;
import cz.agents.alite.vis.layer.GroupLayer;
import cz.agents.alite.vis.layer.VisLayer;
import cz.agents.alite.vis.layer.common.CommonLayer;
import java.awt.event.MouseEvent;
import javax.swing.event.MouseInputAdapter;

public class VisualInteractionLayer extends CommonLayer {

    private VisualInteractionListener interactionListener;

    VisualInteractionLayer(VisualInteractionListener listener) {
        this.interactionListener = listener;
    }

    @Override
    public void init(Vis vis) {
        super.init(vis);

        vis.addMouseListener(new MouseInputAdapter() {

            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);

                double x = Vis.transInvX(e.getX());
                double y = Vis.transInvY(e.getY());
                interactionListener.interact(x, y);
            }
        });

    }

    public static VisLayer create(final VisualInteractionListener entity) {
        GroupLayer group = GroupLayer.create();

        // interaction
        group.addSubLayer(new VisualInteractionLayer(entity));

        return group;
    }

    @Override
    public String getLayerDescription() {
        return "[Interaction] Click to select point.";
    }

    public interface VisualInteractionListener {

        public void interact(double x, double y);
    }
}
