package tacv.vis;

import cz.agents.alite.vis.element.Line;
import cz.agents.alite.vis.element.aggregation.LineElements;
import cz.agents.alite.vis.layer.VisLayer;
import cz.agents.alite.vis.layer.common.CommonLayer;
import cz.agents.alite.vis.layer.terminal.LineLayer;
import cz.agents.alite.vis.layer.toggle.KeyToggleLayer;
import java.awt.Color;
import java.util.ArrayList;
import tacv.universe.world.CollisionZone;

public class ZoneLayer extends CommonLayer {

    public static VisLayer create(final CollisionZone collisionZone) {
        KeyToggleLayer toggle = KeyToggleLayer.create("z");

        final ArrayList<Line> lines = new ArrayList<Line>();
        for (ArrayList<Line> zoneLine : collisionZone.getLines()) {
            lines.addAll(zoneLine);
        }
        LineLayer lineLayer = LineLayer.create(new LineElements() {

               @Override
               public Color getColor() {
                   return Color.YELLOW;
               }

               @Override
               public int getStrokeWidth() {
                   return 1;
               }

               @Override
               public Iterable<? extends Line> getLines() {
                   return lines;
               }
               
           });
        lineLayer.setHelpOverrideString("[Zones] This layer shows zones collision envelopes.");
        toggle.addSubLayer(lineLayer);

        return toggle;
    }
    
}
